﻿label main_menu:
    return

label place_ships (side, fleet):
    $ temp_copy = [s for s in fleet]
    $ orientation = "horizontal"
    while temp_copy:
        show screen battleship_main_screen (game.player)
        show screen battleship_fleet_view (temp_copy, orientation)
        "Pick a ship.{w=.5}{nw}"
        call screen battleship_fleet_view (temp_copy, orientation)
        $ ret = _return
        if isinstance (ret, Ship):
            "Place the [ret.tag]!{w=.5}{nw}"
            $ temp_copy.remove (ret)
            $ placed = False
            while not placed:
                call screen battleship_placement_screen (side)
                $ x, y = _return
                $ placed = side.place (ret, x, y, orientation)
                if not placed:
                    "Try again, please.{w=.5}{nw}"
        elif ret == "quit":
            "Good night, capt'n!"
            $ renpy.quit ()
        elif ret == "reset":
            $ temp_copy = [s for s in fleet]
            $ side.clear ()
        elif ret in ["horizontal", "vertical"]:
            $ orientation = ret
    return

label start:
    scene black

    call screen confirm ("Do you want instructions?", Return (True), Return (False))
    if _return:
        call screen help

    $ game = Game ()

    $ fleet = [Ship ("aircraft carrier", 5), Ship ("battleship", 4), Ship ("cruiser", 3), Ship ("submarine", 3), Ship ("patrol", 2)]

    call place_ships (game.player, fleet) from _call_place_ships
    $ game.ai.randomly_place_fleet (fleet)

    scene black

    while not game.finished ():
        show screen battleship_main_screen (game.player)
        show screen battleship_targetting_screen (game.ai)
        "Your turn.{w=.5}{nw}"
        call screen battleship_targetting_screen (game.ai)
        $ ret = _return
        show screen battleship_targetting_screen (game.ai)

        if ret == "error":
            "Sorry, Dave. I'm afraid I can't do that."
        elif ret == "quit":
            "You quit the game."
            return
        else:
            $ x, y = ret
            $ result = game.ai.incoming_shot (x, y)
            if result == miss:
                "You missed.{w=.5}{nw}"
            elif result == hit:
                "You hit a ship.{w=.5}{nw}"
            elif result == sunk:
                "You hit a ship. It sunk to the ground."

            if not game.ai.lost ():
                $ x, y, ret = game.ai.brain.turn ()
                $ Y = chr (65+y)
                $ X = x + 1
                "The Evil Empire fired at [Y][X] ...{w=.5}{nw}"
                if ret == sunk:
                    $ name = game.player.ocean [y][x].tag
                    "They sunk your [name]!{w=.5}{nw}"
                elif ret == hit:
                    $ name = game.player.ocean [y][x].tag
                    "They hit your [name]!{w=.5}{nw}"
                else:
                    "They missed.{w=.3}{nw}"

    if game.ai.lost ():
        "YOU HAVE WON!"
    elif game.player.lost ():
        "You've lost. Try again."

    return
